#coding:utf-8
import math
import turtle
Delta=50
# draw a line from (x1, y1) to (x2, y2)
def drawLine (ttl, x1, y1, x2, y2):
    ttl.penup()
    ttl.goto (x1, y1)
    ttl.pendown()
    ttl.goto (x2, y2)
    ttl.penup()

# write label at location x, y
def labelPoint (ttl, x, y, label):
    ttl.penup()
    ttl.goto (x, y)
    ttl.pendown()
    ttl.write (label)
    ttl.penup()

def drawGridMark (ttl, x, y, isVertical):
    if isVertical :
        drawLine (ttl, x, y + 5, x, y - 5)
    else:
        drawLine (ttl, x - 5, y, x + 5, y)

def labelGridPoint (ttl, x, y, isVertical, text):
    if isVertical:
        labelPoint (ttl, x - Delta//5, y - Delta//5, text)
    else:
        labelPoint (ttl, x + Delta//5, y, text)

def drawGridScaled (ttl):
  # draw the axes
    drawLine (ttl, -400, 0, 400, 0)
    drawLine (ttl, 0, 400, 0, -400)

    # label the x axis
    for x in [i*Delta for i in range(-6,7)]:
        drawGridMark (ttl, x, 0, True)
        labelGridPoint (ttl, x-5, -10, True, (x//Delta, 0))

    # label the y axis
    for y in [i*Delta for i in range(-5,6) if i!=0]:
        drawGridMark (ttl, 0, y, False)
        labelGridPoint (ttl, 0, y-8, False, (0, y//Delta))

def drawFnScaled (ttl, fn, lower, upper, step):
    ttl.penup()
    x = lower
    y = fn (x)
    scaledX = x * Delta
    scaledY = y * Delta
    ttl.goto (scaledX, scaledY)
    ttl.pendown()
    while x < upper:
        x = x + step
        y = fn ( x )
        scaledX, scaledY = x * Delta, y * Delta
        ttl.goto (scaledX, scaledY)
    ttl.penup()
def Abs(x):
    return x if x>0 else -x
def Sqrt(x):
    y1=1
    y2=(y1+x/y1)/2
    while Abs(y1/y2-1)>1e-5:
        y1,y2=y2,(y2+x/y2)/2
    return y2
def myFunc (x):
    return (x ** 2 - 4)
def F1(x) :
    if 40-3*x*x<=0 :
        return 1/2*(-x)
    else :
        return 1/2*(-x-Sqrt(40-3*x*x))
def F2(x) :
    if 40-3*x*x<=0 :
        return 1/2*(x)
    else :
        return 1/2*(x-Sqrt(40-3*x*x))
def F3(x):
    if 40-3*x*x<=0 :
        return 1/2*(-x)
    else :
        return 1/2*(-x+Sqrt(40-3*x*x))
def F4(x):
    if 40-3*x*x<=0 :
        return 1/2*(x)
    else :
        return 1/2*(x+Sqrt(40-3*x*x))
def  main():
    # put label on top of page
    #turtle.title ('Graphs of Functions')

    # setup screen size
    #turtle.setup (1200, 1200, 0, 0)

    # create a turtle object
    ttl = turtle.Turtle()

    # draw the grid
    #drawGridScaled (ttl)

    # draw sine finction
    ttl.pencolor ('red')
    drawFnScaled (ttl, F1,-Sqrt(40)/Sqrt(3), 0, 0.005)
    drawFnScaled (ttl, F2,0, Sqrt(40)/Sqrt(3), 0.005)
    drawFnScaled (ttl, F3,-Sqrt(40)/Sqrt(3), 0, 0.005)
    drawFnScaled (ttl, F4,0, Sqrt(40)/Sqrt(3), 0.005)
    

    # persist drawing
    turtle.done()

if __name__ == "__main__":
    main()
